

hangecom (//)changequote([,])
define(calc, [esyscmd(perl -e 'printf ($1)')])dnl
define(VCOUNT, 0)dnl
define(vlabel, [[// ]Vertex $1 = VCOUNT define($1, VCOUNT)define([VCOUNT], incr(VCOUNT))])dnl
define(pi, 3.1415926)dnl
//===========================================================//
		define(LU, 0.16)dnl  //upstream length
		define(LD, 0.14)dnl    //downstream length
		define(LC, 0.032)dnl    //length part bended 
		define(H, 0.016)dnl    //Total Height
		define(W, 0.002)dnl  //Total width
		define(D, 0.012)dnl    //Cylinder Diameter (must be < than H)
//===========================================================//
dnl
define(LT, calc(LU+LD))dnl
define(L1, calc(LU-LC))dnl
define(L2, calc(LU+LC))dnl
define(px, calc(D/2.0))dnl
define(pxinnen,calc(sqrt((D*D/4.0)/(1+(H*H/4)/(px*px)))))dnl
define(pyinnen,calc(pxinnen*H/2.0/px))dnl
define(R2, calc(D))dnl
dnl
define(xo, 0.0)dnl
define(yo, 0.0)dnl
define(zo, 0.0)dnl
dnl
define(p1x, calc(LU-px))dnl
define(p2x, calc(LU-R2))dnl
define(p2y, calc(H/2.0))dnl
define(p3x, calc(LU-px))dnl
define(p4x, calc(LU+px))dnl
define(p5x, calc(LU+R2))dnl
define(p6x, calc(LU+px))dnl
define(p7x, calc(LU-pxinnen))dnl
define(p7y, calc(H/2.0-pyinnen))dnl
define(p8x, calc(LU-pxinnen))dnl
define(p8y, calc(H/2.0+pyinnen))dnl
define(p9x, calc(LU+pxinnen))dnl
define(p9y, calc(H/2.0+pyinnen))dnl
define(p10x, calc(LU+pxinnen))dnl
define(p10y, calc(H/2.0-pyinnen))dnl
define(p11x, calc(LU-D/2.0))dnl
define(p12x, calc(LU+D/2.0))dnl
define(po1x, calc(LU+LD))dnl
define(p13y, calc(H/2.0+D/2.0))dnl
define(p14y, calc(H/2.0-D/2.0))dnl
dnl


convertToMeters 1;

vertices
    (
    (xo yo zo) vlabel(i0b)  
    (xo yo W) vlabel(i0t)   
    (xo H zo) vlabel(i1b)  
    (xo H W) vlabel(i1t)  
    (L1 yo zo) vlabel(i2b)  
    (L1 yo W) vlabel(i2t)   
    (L1 H zo) vlabel(i3b)  
    (L1 H W) vlabel(i3t)  
     
    (po1x yo zo) vlabel(o0b)  
    (po1x yo W) vlabel(o0t)   
    (po1x H zo) vlabel(o1b)  
    (po1x H W) vlabel(o1t)   
    (L2 yo zo) vlabel(o2b)  
    (L2 yo W) vlabel(o2t)   
    (L2 H zo) vlabel(o3b)  
    (L2 H W) vlabel(o3t)   

    (p1x yo zo) vlabel(v1b)   
    (p1x yo W) vlabel(v1t)   
    (p3x H zo) vlabel(v3b)   
    (p3x H W) vlabel(v3t)   

    (p4x H zo) vlabel(v4b)   
    (p4x H W) vlabel(v4t)   
    (p6x xo zo) vlabel(v6b)   
    (p6x xo W) vlabel(v6t)   

    (p7x p7y zo) vlabel(v7b)   
    (p7x p7y W) vlabel(v7t)   
    (p8x p8y zo) vlabel(v8b)   
    (p8x p8y W) vlabel(v8t)   
    (p9x p9y zo) vlabel(v9b)   
    (p9x p9y W) vlabel(v9t)   
    (p10x p10y zo) vlabel(v10b)   
    (p10x p10y W) vlabel(v10t)   

);
edges
(
arc v1b v3b (p2x p2y zo)
arc v1t v3t (p2x p2y W)
arc v6b v4b (p5x p2y zo)
arc v6t v4t (p5x p2y W)
arc v7b v8b (p11x p2y zo)
arc v7t v8t (p11x p2y W)
arc v8b v9b (LU p13y zo)
arc v8t v9t (LU p13y W)
arc v9b v10b (p12x p2y zo)
arc v9t v10t (p12x p2y W)
arc v7b v10b (LU p14y zo)
arc v7t v10t (LU p14y W)

line i0b v1b
line v1b v6b
line v6b o0b
line i0t v1t
line v1t v6t
line v6t o0t

line i1b v3b
line v3b v4b
line v4b o1b
line i1t v3t
line v3t v4t
line v4t o1t

);


blocks
(
// block 0_1
	hex (i0b i2b i3b i1b i0t i2t i3t i1t) (1 1 1) simpleGrading (1 1 1)    
    	
//block 0_2
	hex (i2b v1b v3b i3b i2t v1t v3t i3t) (1 1 1) simpleGrading (1 1 1) 
    
    // block 1
    hex (v1b v7b v8b v3b v1t v7t v8t v3t) (1 1 1) simpleGrading (1 1 1) 
	// block 2
    hex (v8b v9b v4b v3b v8t v9t v4t v3t) (1 1 1) simpleGrading (1 1 1) 
// block 3
    hex (v1b v6b v10b v7b v1t v6t v10t v7t) (1 1 1) simpleGrading (1 1 1) 
// block 4
    hex (v10b v6b v4b v9b v10t v6t v4t v9t) (1 1 1) simpleGrading (1 1 1) 
	
	// block 5_1
	hex (v6b o2b o3b v4b v6t o2t o3t v4t) (1 1 1) simpleGrading (1 1 1) 
	// block 5_2
    	hex (o2b o0b o1b o3b o2t o0t o1t o3t) (1 1 1) simpleGrading (1 1 1) 

);
patches
(
    patch inlet
    (    
	(i0b i0t i1t i1b)
	)
    patch outlet
    (
    	(o0t o0b o1b o1t)
    )
	
	
    wall fixedWalls 
    (
	(i1b i1t i3t i3b) //up
	(i3b i3t v3t v3b) 
	(v3b v3t v4t v4b) 
	(v4b v4t o3t o3b)
	(o3b o3t o1t o1b)
		
	(i0b i0t i2t i2b) //down	
	(i2b i2t v1t v1b) 
	(v1b v1t v6t v6b) 
	(v6b v6t o2t o2b)
	(o2b o2t o0t o0b)
	
)
wall cylinder
(
	(v7b v7t v10t v10b) //cylinder
	(v10b v10t v9t v9b) 
	(v9b v9t v8t v8b) 
	(v8b v8t v7t v7b) 
	
    )
	empty frontandback
    (
    	(i0b i1b i3b i2b) //b    	
	(i2b i3b v3b v1b) //b
	(v1b v3b v8b v7b) 
	(v8b v3b v4b v9b) 
    	(v9b v4b v6b v10b) 
    	(v1b v7b v10b v6b) 
    	(v6b v4b o3b o2b) 
    	(o2b o3b o1b o0b) 
    	
    	(i0t i2t i3t i1t) //t
    	(i2t v1t v3t i3t) //t
    	(v1t v7t v8t v3t) 
    	(v8t v9t v4t v3t) 
    	(v10t v6t v4t v9t)
    	(v7t v1t v6t v10t)
	(v6t o2t o3t v4t) 
    	(o2t o0t o1t o3t) 
    	
    )
);

mergePatchPairs 
(

);
 
